## astc-encoder 4.7.0+ds

=== CMakeLists.txt ===
#  SPDX-License-Identifier: Apache-2.0
#  ----------------------------------------------------------------------------
#  Copyright 2020-2024 Arm Limited
#
#  Licensed under the Apache License, Version 2.0 (the "License"); you may not
#  use this file except in compliance with the License. You may obtain a copy
#  of the License at:
#
#      http://www.apache.org/licenses/LICENSE-2.0
#
#  Unless required by applicable law or agreed to in writing, software
#  distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
#  WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
#  License for the specific language governing permissions and limitations
#  under the License.
#  ----------------------------------------------------------------------------

# CMake configuration
cmake_minimum_required(VERSION 3.15)
cmake_policy(SET CMP0069 NEW)  # LTO support
cmake_policy(SET CMP0091 NEW)  # MSVC runtime support

if(MSVC)
    add_compile_options("/wd4324") # Disable structure was padded due to alignment specifier
endif()

project(astcencoder VERSION 4.7.0)

set(CMAKE_CXX_STANDARD 14)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)
set(CMAKE_EXPORT_COMPILE_COMMANDS 1)
set(CMAKE_XCODE_ATTRIBUTE_VALID_ARCHS "x86_64 x86_64h arm64")

include(CTest)

option(ASTCENC_ISA_AVX2 "Enable astcenc builds for AVX2 SIMD")
option(ASTCENC_ISA_SSE41 "Enable astcenc builds for SSE4.1 SIMD")
option(ASTCENC_ISA_SSE2 "Enable astcenc builds for SSE2 SIMD")
option(ASTCENC_ISA_NEON "Enable astcenc builds for NEON SIMD")
option(ASTCENC_ISA_NONE "Enable astcenc builds for no SIMD")
option(ASTCENC_ISA_NATIVE "Enable astcenc builds for native SIMD")
option(ASTCENC_DECOMPRESSOR "Enable astcenc builds for decompression only")
option(ASTCENC_SHAREDLIB "Enable astcenc builds with core library shared objects")
option(ASTCENC_DIAGNOSTICS "Enable astcenc builds with diagnostic trace")
option(ASTCENC_ASAN "Enable astcenc builds with address sanitizer")
option(ASTCENC_UNITTEST "Enable astcenc builds with unit tests")
option(ASTCENC_INVARIANCE "Enable astcenc floating point invariance" ON)
option(ASTCENC_CLI "Enable build of astcenc command line tools" ON)

# Preflight for some macOS-specific build options
if("${CMAKE_SYSTEM_NAME}" STREQUAL "Darwin")
    option(ASTCENC_UNIVERSAL_BUILD "Enable universal multi-arch build" ON)

    if(${ASTCENC_UNIVERSAL_BUILD})
        set(ASTCENC_ISA_SSE41 ON)
        set(ASTCENC_ISA_AVX2 ON)
        set(ASTCENC_ISA_NEON ON)

        if(${ASTCENC_ISA_SSE2})
            message(FATAL_ERROR "ISA_SSE2 cannot be used in a universal build")
        endif()

        if(${ASTCENC_ISA_NONE})
            message(FATAL_ERROR "ISA_NONE cannot be used in a universal build")
        endif()

        if(${ASTCENC_ISA_NATIVE})
            message(FATAL_ERROR "ISA_NATIVE cannot be used in a universal build")
        endif()
    endif()
else()
    set(ASTCENC_UNIVERSAL_BUILD OFF)
endif()

# Count options which MUST be x64
set(ASTCENC_X64_ISA_COUNT 0)
set(ASTCENC_CONFIGS ${ASTCENC_ISA_AVX2} ${ASTCENC_ISA_SSE41} ${ASTCENC_ISA_SSE2})
foreach(ASTCENC_CONFIG ${ASTCENC_CONFIGS})
    if(${ASTCENC_CONFIG})
        math(EXPR ASTCENC_X64_ISA_COUNT "${ASTCENC_X64_ISA_COUNT} + 1")
    endif()
endforeach()

# Count options which MUST be arm64
set(ASTCENC_ARM64_ISA_COUNT 0)
set(ASTCENC_CONFIGS ${ASTCENC_ISA_NEON})
foreach(ASTCENC_CONFIG ${ASTCENC_CONFIGS})
    if(${ASTCENC_CONFIG})
        math(EXPR ASTCENC_ARM64_ISA_COUNT "${ASTCENC_ARM64_ISA_COUNT} + 1")
    endif()
endforeach()

# Non-macOS builds
if(NOT "${CMAKE_SYSTEM_NAME}" STREQUAL "Darwin")
    if(("${ASTCENC_ARM64_ISA_COUNT}" GREATER 0) AND ("${ASTCENC_X64_ISA_COUNT}" GREATER 0))
        message(FATAL_ERROR "Builds can only support a single architecture per configure.")
    endif()
endif()

# If nothing more specific is set then fall back on the compiler's defaults
if(("${ASTCENC_ARM64_ISA_COUNT}" EQUAL 0) AND ("${ASTCENC_X64_ISA_COUNT}" EQUAL 0) AND (NOT "${ASTCENC_ISA_NONE}"))
    set(ASTCENC_ISA_NATIVE ON)
endif()

function(printopt optName optVal)
    if(${optVal})
        message(STATUS "  ${optName}  - ON")
    else()
        message(STATUS "  ${optName}  - OFF")
    endif()
endfunction()

if("${ASTCENC_BLOCK_MAX_TEXELS}")
     message(STATUS "  Max block texels - ${ASTCENC_BLOCK_MAX_TEXELS}")
endif()

printopt("AVX2 backend   " ${ASTCENC_ISA_AVX2})
printopt("SSE4.1 backend " ${ASTCENC_ISA_SSE41})
printopt("SSE2 backend   " ${ASTCENC_ISA_SSE2})
printopt("NEON backend   " ${ASTCENC_ISA_NEON})
printopt("NONE backend   " ${ASTCENC_ISA_NONE})
printopt("NATIVE backend " ${ASTCENC_ISA_NATIVE})
if("${CMAKE_SYSTEM_NAME}" STREQUAL "Darwin")
    printopt("Universal bin  " ${ASTCENC_UNIVERSAL_BUILD})
endif()
printopt("Invariance     " ${ASTCENC_INVARIANCE})
printopt("Shared libs    " ${ASTCENC_SHAREDLIB})
printopt("Decompressor   " ${ASTCENC_DECOMPRESSOR})
printopt("Diagnostics    " ${ASTCENC_DIAGNOSTICS})
printopt("ASAN           " ${ASTCENC_ASAN})
printopt("Unit tests     " ${ASTCENC_UNITTEST})

# Subcomponents
add_subdirectory(Source)

# Configure package archive
if(ASTCENC_PACKAGE)
    if("${CMAKE_SYSTEM_NAME}" STREQUAL "Darwin")
        string(TOLOWER "macOS" ASTCENC_PKG_OS)
    else()
        string(TOLOWER ${CMAKE_SYSTEM_NAME} ASTCENC_PKG_OS)
    endif()

    set(CPACK_PACKAGE_FILE_NAME "astcenc-${CMAKE_PROJECT_VERSION}-${ASTCENC_PKG_OS}-${ASTCENC_PACKAGE}")
    set(CPACK_INCLUDE_TOPLEVEL_DIRECTORY FALSE)
    set(CPACK_PACKAGE_CHECKSUM SHA256)
    set(CPACK_GENERATOR ZIP)

    include(CPack) # Must be included after CPack configuration.
endif()

=== Source/CMakeLists.txt ===
#  SPDX-License-Identifier: Apache-2.0
#  ----------------------------------------------------------------------------
#  Copyright 2020-2023 Arm Limited
#
#  Licensed under the Apache License, Version 2.0 (the "License"); you may not
#  use this file except in compliance with the License. You may obtain a copy
#  of the License at:
#
#      http://www.apache.org/licenses/LICENSE-2.0
#
#  Unless required by applicable law or agreed to in writing, software
#  distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
#  WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
#  License for the specific language governing permissions and limitations
#  under the License.
#  ----------------------------------------------------------------------------

# Overwrite the LTO flags to force fat LTO; worth 3-4% performance
# See https://gitlab.kitware.com/cmake/cmake/-/issues/16808
if(CMAKE_CXX_COMPILER_ID MATCHES "GNU|Clang" AND ${ASTCENC_CLI})
    set(CMAKE_CXX_COMPILE_OPTIONS_IPO "-flto")
endif()

if(${ASTCENC_DECOMPRESSOR})
    set(ASTCENC_CODEC dec)
else()
    set(ASTCENC_CODEC enc)
endif()

set(ASTCENC_ARTIFACTS native none neon avx2 sse4.1 sse2)
set(ASTCENC_CONFIGS ${ASTCENC_ISA_NATIVE} ${ASTCENC_ISA_NONE} ${ASTCENC_ISA_NEON} ${ASTCENC_ISA_AVX2} ${ASTCENC_ISA_SSE41} ${ASTCENC_ISA_SSE2})
list(LENGTH ASTCENC_ARTIFACTS ASTCENC_ARTIFACTS_LEN)
math(EXPR ASTCENC_ARTIFACTS_LEN "${ASTCENC_ARTIFACTS_LEN} - 1")

foreach(INDEX RANGE ${ASTCENC_ARTIFACTS_LEN})
    list(GET ASTCENC_ARTIFACTS ${INDEX} ASTCENC_ARTIFACT)
    list(GET ASTCENC_CONFIGS ${INDEX} ASTCENC_CONFIG)
    if(${ASTCENC_CONFIG})
        set(ASTCENC_ISA_SIMD ${ASTCENC_ARTIFACT})

        if(${ASTCENC_ISA_SIMD} MATCHES "neon")
           set(CMAKE_OSX_ARCHITECTURES arm64)
        elseif(${ASTCENC_ISA_SIMD} MATCHES "avx2")
           set(CMAKE_OSX_ARCHITECTURES x86_64h)
        elseif(NOT ${ASTCENC_ISA_SIMD} MATCHES "none")
           set(CMAKE_OSX_ARCHITECTURES x86_64)
        endif()

        include(cmake_core.cmake)
    endif()
endforeach()

if(${ASTCENC_CLI} AND ${ASTCENC_UNIVERSAL_BUILD})
    add_custom_target(
        astc${ASTCENC_CODEC}
            ALL
            COMMAND
                lipo -create -output $<TARGET_FILE_DIR:astc${ASTCENC_CODEC}-sse4.1>/astc${ASTCENC_CODEC} -arch x86_64 $<TARGET_FILE:astc${ASTCENC_CODEC}-sse4.1> -arch x86_64h $<TARGET_FILE:astc${ASTCENC_CODEC}-avx2> -arch arm64 $<TARGET_FILE:astc${ASTCENC_CODEC}-neon>
            VERBATIM)

    add_dependencies(
        astc${ASTCENC_CODEC}
            astc${ASTCENC_CODEC}-sse4.1
            astc${ASTCENC_CODEC}-avx2
            astc${ASTCENC_CODEC}-neon)

    install(PROGRAMS $<TARGET_FILE_DIR:astc${ASTCENC_CODEC}-sse4.1>/astc${ASTCENC_CODEC}
            DESTINATION bin)
endif()

if(${ASTCENC_SHAREDLIB} AND ${ASTCENC_UNIVERSAL_BUILD})
    add_custom_target(
        astc${ASTCENC_CODEC}-shared
            ALL
            COMMAND
                lipo -create -output $<TARGET_FILE_DIR:astc${ASTCENC_CODEC}-sse4.1-shared>/libastc${ASTCENC_CODEC}-shared.dylib -arch x86_64 $<TARGET_FILE:astc${ASTCENC_CODEC}-sse4.1-shared> -arch x86_64h $<TARGET_FILE:astc${ASTCENC_CODEC}-avx2-shared> -arch arm64 $<TARGET_FILE:astc${ASTCENC_CODEC}-neon-shared>
            VERBATIM)

    add_dependencies(
        astc${ASTCENC_CODEC}-shared
            astc${ASTCENC_CODEC}-sse4.1-shared
            astc${ASTCENC_CODEC}-avx2-shared
            astc${ASTCENC_CODEC}-neon-shared)

    install(PROGRAMS $<TARGET_FILE_DIR:astc${ASTCENC_CODEC}-sse4.1-shared>/libastc${ASTCENC_CODEC}-shared.dylib
            DESTINATION lib)
endif()

# - - - - - - - - - - - - - - - - - -
# Unit testing
if(${ASTCENC_UNITTEST})
    set(INSTALL_GTEST OFF CACHE BOOL "" FORCE)
    set(CMAKE_OSX_ARCHITECTURES x86_64;arm64)
    add_subdirectory(GoogleTest)
    enable_testing()
    add_subdirectory(UnitTest)
endif()

=== Source/UnitTest/CMakeLists.txt ===
#  SPDX-License-Identifier: Apache-2.0
#  ----------------------------------------------------------------------------
#  Copyright 2020-2023 Arm Limited
#
#  Licensed under the Apache License, Version 2.0 (the "License"); you may not
#  use this file except in compliance with the License. You may obtain a copy
#  of the License at:
#
#      http://www.apache.org/licenses/LICENSE-2.0
#
#  Unless required by applicable law or agreed to in writing, software
#  distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
#  WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
#  License for the specific language governing permissions and limitations
#  under the License.
#  ----------------------------------------------------------------------------

set(ASTCENC_ARTIFACTS native none neon avx2 sse4.1 sse2)
set(ASTCENC_CONFIGS ${ASTCENC_ISA_NATIVE} ${ASTCENC_ISA_NONE} ${ASTCENC_ISA_NEON} ${ASTCENC_ISA_AVX2} ${ASTCENC_ISA_SSE41} ${ASTCENC_ISA_SSE2})
list(LENGTH ASTCENC_ARTIFACTS ASTCENC_ARTIFACTS_LEN)
math(EXPR ASTCENC_ARTIFACTS_LEN "${ASTCENC_ARTIFACTS_LEN} - 1")

foreach(INDEX RANGE ${ASTCENC_ARTIFACTS_LEN})
    list(GET ASTCENC_ARTIFACTS ${INDEX} ASTCENC_ARTIFACT)
    list(GET ASTCENC_CONFIGS ${INDEX} ASTCENC_CONFIG)
    if(${ASTCENC_CONFIG})
        set(ASTCENC_ISA_SIMD ${ASTCENC_ARTIFACT})

        if(${ASTCENC_ISA_SIMD} MATCHES "neon")
           set(CMAKE_OSX_ARCHITECTURES arm64)
        elseif(${ASTCENC_ISA_SIMD} MATCHES "avx2")
           set(CMAKE_OSX_ARCHITECTURES x86_64h)
        elseif(NOT ${ASTCENC_ISA_SIMD} MATCHES "none")
           set(CMAKE_OSX_ARCHITECTURES x86_64)
        endif()

        include(cmake_core.cmake)
    endif()
endforeach()

=== debian/changelog ===
astc-encoder (4.7.0+ds-2build3) noble; urgency=medium

  * No-change rebuild against libstb0t64.

 -- Colin Watson <cjwatson@ubuntu.com>  Mon, 15 Apr 2024 01:56:53 +0100

astc-encoder (4.7.0+ds-2build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 17:41:23 +0000

astc-encoder (4.7.0+ds-2build1) noble; urgency=medium

  * No-change rebuild against libstb0t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 19 Mar 2024 00:54:12 +0000

astc-encoder (4.7.0+ds-2) unstable; urgency=medium

  * Upload to unstable.
  * Run full test suite in autopkgtest

 -- Timo Röhling <roehling@debian.org>  Mon, 22 Jan 2024 21:16:30 +0100

astc-encoder (4.7.0+ds-1) experimental; urgency=medium

  * New upstream version 4.7.0+ds
  * Update patches
    - Drop 0007-Add-missing-limits-include.patch (merged upstream)
    - Drop 0009-Prevent-unit-test-failures-due-to-rounding-errors.patch
      (rejected)
  * Bump minimum version for symbols
  * Do not run test suite on i386 (officially unsupported)

 -- Timo Röhling <roehling@debian.org>  Tue, 16 Jan 2024 22:00:37 +0100

astc-encoder (4.6.0+ds-2) experimental; urgency=medium

  * Make unit tests more robust

 -- Timo Röhling <roehling@debian.org>  Tue, 28 Nov 2023 22:09:38 +0100

astc-encoder (4.6.0+ds-1) experimental; urgency=medium

  * New upstream version 4.6.0+ds
  * Reformat d/control
  * Bump SONAME to 5d

 -- Timo Röhling <roehling@debian.org>  Sat, 11 Nov 2023 23:22:58 +0100

=== debian/control ===
Source: astc-encoder
Section: graphics
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Timo Röhling <roehling@debian.org>
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 libgtest-dev <!nocheck>,
 libstb-dev,
 libtinyexr-dev,
 libz-dev,
 pkg-config <!nocheck>,
Homepage: https://github.com/ARM-software/astc-encoder
Standards-Version: 4.6.2
Rules-Requires-Root: no
Vcs-Git: https://salsa.debian.org/roehling/astc-encoder.git
Vcs-Browser: https://salsa.debian.org/roehling/astc-encoder
Description: ASTC image compression and decompression
 The Adaptive Scalable Texture Compression (ASTC) format, developed by
 Arm® and AMD, has been adopted as an official extension to the Open GL®,
 OpenGL ES, and Vulkan® graphics APIs. It provides a major step forward
 both in terms of image quality at a given bitrate, and in terms of the
 format and bitrate flexibility available to content creators. This
 allows more assets to use compression, often at a reduced bitrate
 compared to legacy formats, reducing memory bandwidth and energy
 consumption.

Package: astcenc
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: ${source:Synopsis} tool
 ${source:Extended-Description}
 .
 This package provides the command-line tool to compress and decompress
 images.

Package: libastcenc5d
Section: libs
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Multi-Arch: same
Description: ${source:Synopsis} library
 ${source:Extended-Description}
 .
 This package provides the runtime library for ASTC support.

Package: libastcenc-dev
Section: libdevel
Architecture: any
Depends:
 ${misc:Depends},
 libastcenc5d (= ${binary:Version}),
Multi-Arch: same
Description: ${source:Synopsis} library headers
 ${source:Extended-Description}
 .
 This package provides the development headers to include ASTC support
 in other applications.

=== debian/tests/control ===
Tests: test-suite
Depends: libastcenc-dev, libgtest-dev, cmake, g++ | c++-compiler
Architecture: !i386
Restrictions: allow-stderr

## astc-encoder 4.8.0+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -21,10 +21,11 @@
 cmake_policy(SET CMP0091 NEW)  # MSVC runtime support
 
 if(MSVC)
-    add_compile_options("/wd4324") # Disable structure was padded due to alignment specifier
+    # Disable structure was padded due to alignment specifier
+    add_compile_options("/wd4324")
 endif()
 
-project(astcencoder VERSION 4.7.0)
+project(astcencoder VERSION 4.8.0)
 
 set(CMAKE_CXX_STANDARD 14)
 set(CMAKE_CXX_STANDARD_REQUIRED ON)
@@ -44,6 +45,7 @@
 option(ASTCENC_SHAREDLIB "Enable astcenc builds with core library shared objects")
 option(ASTCENC_DIAGNOSTICS "Enable astcenc builds with diagnostic trace")
 option(ASTCENC_ASAN "Enable astcenc builds with address sanitizer")
+option(ASTCENC_UBSAN "Enable astcenc builds with undefined behavior sanitizer")
 option(ASTCENC_UNITTEST "Enable astcenc builds with unit tests")
 option(ASTCENC_INVARIANCE "Enable astcenc floating point invariance" ON)
 option(ASTCENC_CLI "Enable build of astcenc command line tools" ON)
@@ -129,6 +131,7 @@
 printopt("Decompressor   " ${ASTCENC_DECOMPRESSOR})
 printopt("Diagnostics    " ${ASTCENC_DIAGNOSTICS})
 printopt("ASAN           " ${ASTCENC_ASAN})
+printopt("UBSAN          " ${ASTCENC_UBSAN})
 printopt("Unit tests     " ${ASTCENC_UNITTEST})
 
 # Subcomponents

=== Source/CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 #  SPDX-License-Identifier: Apache-2.0
 #  ----------------------------------------------------------------------------
-#  Copyright 2020-2023 Arm Limited
+#  Copyright 2020-2024 Arm Limited
 #
 #  Licensed under the Apache License, Version 2.0 (the "License"); you may not
 #  use this file except in compliance with the License. You may obtain a copy
@@ -40,10 +40,18 @@
 
         if(${ASTCENC_ISA_SIMD} MATCHES "neon")
            set(CMAKE_OSX_ARCHITECTURES arm64)
+        elseif(${ASTCENC_ISA_SIMD} MATCHES "sse2")
+           set(CMAKE_OSX_ARCHITECTURES x86_64)
+        elseif(${ASTCENC_ISA_SIMD} MATCHES "sse4.1")
+           set(CMAKE_OSX_ARCHITECTURES x86_64)
         elseif(${ASTCENC_ISA_SIMD} MATCHES "avx2")
            set(CMAKE_OSX_ARCHITECTURES x86_64h)
-        elseif(NOT ${ASTCENC_ISA_SIMD} MATCHES "none")
-           set(CMAKE_OSX_ARCHITECTURES x86_64)
+        elseif(${ASTCENC_ISA_SIMD} MATCHES "none")
+           # Using "none" uses implicit architecture
+        elseif(${ASTCENC_ISA_SIMD} MATCHES "native")
+           # Using "native" uses implicit architecture
+        else()
+            message(FATAL_ERROR "'${ASTCENC_ISA_SIMD}' is unknown ISA")
         endif()
 
         include(cmake_core.cmake)

=== Source/UnitTest/CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 #  SPDX-License-Identifier: Apache-2.0
 #  ----------------------------------------------------------------------------
-#  Copyright 2020-2023 Arm Limited
+#  Copyright 2020-2024 Arm Limited
 #
 #  Licensed under the Apache License, Version 2.0 (the "License"); you may not
 #  use this file except in compliance with the License. You may obtain a copy
@@ -28,10 +28,18 @@
 
         if(${ASTCENC_ISA_SIMD} MATCHES "neon")
            set(CMAKE_OSX_ARCHITECTURES arm64)
+        elseif(${ASTCENC_ISA_SIMD} MATCHES "sse2")
+           set(CMAKE_OSX_ARCHITECTURES x86_64)
+        elseif(${ASTCENC_ISA_SIMD} MATCHES "sse4.1")
+           set(CMAKE_OSX_ARCHITECTURES x86_64)
         elseif(${ASTCENC_ISA_SIMD} MATCHES "avx2")
            set(CMAKE_OSX_ARCHITECTURES x86_64h)
-        elseif(NOT ${ASTCENC_ISA_SIMD} MATCHES "none")
-           set(CMAKE_OSX_ARCHITECTURES x86_64)
+        elseif(${ASTCENC_ISA_SIMD} MATCHES "none")
+           # Using "none" uses implicit architecture
+        elseif(${ASTCENC_ISA_SIMD} MATCHES "native")
+           # Using "native" uses implicit architecture
+        else()
+            message(FATAL_ERROR "'${ASTCENC_ISA_SIMD}' is unknown ISA")
         endif()
 
         include(cmake_core.cmake)

=== debian/changelog ===
astc-encoder (4.8.0+ds-1) unstable; urgency=medium

  * New upstream version 4.8.0+ds
  * Update d/copyright
  * Bump Standards-Version to 4.7.0
  * Refresh patches (no functional changes)
  * Build-depend on pkgconf instead of pkg-config

 -- Timo Röhling <roehling@debian.org>  Tue, 14 May 2024 13:14:56 +0200

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: astc-encoder
 Section: graphics
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Timo Röhling <roehling@debian.org>
+Maintainer: Timo Röhling <roehling@debian.org>
 Build-Depends:
  debhelper-compat (= 13),
  cmake,
@@ -10,9 +9,9 @@
  libstb-dev,
  libtinyexr-dev,
  libz-dev,
- pkg-config <!nocheck>,
+ pkgconf <!nocheck>,
 Homepage: https://github.com/ARM-software/astc-encoder
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Rules-Requires-Root: no
 Vcs-Git: https://salsa.debian.org/roehling/astc-encoder.git
 Vcs-Browser: https://salsa.debian.org/roehling/astc-encoder

## astc-encoder 5.1.0+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -25,7 +25,7 @@
     add_compile_options("/wd4324")
 endif()
 
-project(astcencoder VERSION 4.8.0)
+project(astcencoder VERSION 5.1.0)
 
 set(CMAKE_CXX_STANDARD 14)
 set(CMAKE_CXX_STANDARD_REQUIRED ON)
@@ -38,6 +38,8 @@
 option(ASTCENC_ISA_AVX2 "Enable astcenc builds for AVX2 SIMD")
 option(ASTCENC_ISA_SSE41 "Enable astcenc builds for SSE4.1 SIMD")
 option(ASTCENC_ISA_SSE2 "Enable astcenc builds for SSE2 SIMD")
+option(ASTCENC_ISA_SVE_256 "Enable astcenc builds for 256-bit SVE SIMD")
+option(ASTCENC_ISA_SVE_128 "Enable astcenc builds for 128-bit SVE SIMD")
 option(ASTCENC_ISA_NEON "Enable astcenc builds for NEON SIMD")
 option(ASTCENC_ISA_NONE "Enable astcenc builds for no SIMD")
 option(ASTCENC_ISA_NATIVE "Enable astcenc builds for native SIMD")
@@ -49,6 +51,7 @@
 option(ASTCENC_UNITTEST "Enable astcenc builds with unit tests")
 option(ASTCENC_INVARIANCE "Enable astcenc floating point invariance" ON)
 option(ASTCENC_CLI "Enable build of astcenc command line tools" ON)
+option(ASTCENC_X86_GATHERS "Enable use of native x86 gathers" ON)
 
 # Preflight for some macOS-specific build options
 if("${CMAKE_SYSTEM_NAME}" STREQUAL "Darwin")
@@ -86,7 +89,7 @@
 
 # Count options which MUST be arm64
 set(ASTCENC_ARM64_ISA_COUNT 0)
-set(ASTCENC_CONFIGS ${ASTCENC_ISA_NEON})
+set(ASTCENC_CONFIGS ${ASTCENC_ISA_NEON} ${ASTCENC_ISA_SVE_128} ${ASTCENC_ISA_SVE_256})
 foreach(ASTCENC_CONFIG ${ASTCENC_CONFIGS})
     if(${ASTCENC_CONFIG})
         math(EXPR ASTCENC_ARM64_ISA_COUNT "${ASTCENC_ARM64_ISA_COUNT} + 1")
@@ -117,22 +120,30 @@
      message(STATUS "  Max block texels - ${ASTCENC_BLOCK_MAX_TEXELS}")
 endif()
 
-printopt("AVX2 backend   " ${ASTCENC_ISA_AVX2})
-printopt("SSE4.1 backend " ${ASTCENC_ISA_SSE41})
-printopt("SSE2 backend   " ${ASTCENC_ISA_SSE2})
-printopt("NEON backend   " ${ASTCENC_ISA_NEON})
-printopt("NONE backend   " ${ASTCENC_ISA_NONE})
-printopt("NATIVE backend " ${ASTCENC_ISA_NATIVE})
+message(STATUS "Arm backend options")
+printopt("SVE 256b backend   " ${ASTCENC_ISA_SVE_256})
+printopt("SVE 128b backend   " ${ASTCENC_ISA_SVE_128})
+printopt("NEON backend       " ${ASTCENC_ISA_NEON})
+message(STATUS "x86-64 backend options")
+printopt("AVX2 backend       " ${ASTCENC_ISA_AVX2})
+printopt("SSE4.1 backend     " ${ASTCENC_ISA_SSE41})
+printopt("SSE2 backend       " ${ASTCENC_ISA_SSE2})
+printopt("Use native gathers " ${ASTCENC_X86_GATHERS})
+message(STATUS "Agnostic backend options")
+printopt("NONE backend       " ${ASTCENC_ISA_NONE})
+printopt("NATIVE backend     " ${ASTCENC_ISA_NATIVE})
+message(STATUS "Build options")
 if("${CMAKE_SYSTEM_NAME}" STREQUAL "Darwin")
-    printopt("Universal bin  " ${ASTCENC_UNIVERSAL_BUILD})
+    printopt("Universal bin      " ${ASTCENC_UNIVERSAL_BUILD})
 endif()
-printopt("Invariance     " ${ASTCENC_INVARIANCE})
-printopt("Shared libs    " ${ASTCENC_SHAREDLIB})
-printopt("Decompressor   " ${ASTCENC_DECOMPRESSOR})
-printopt("Diagnostics    " ${ASTCENC_DIAGNOSTICS})
-printopt("ASAN           " ${ASTCENC_ASAN})
-printopt("UBSAN          " ${ASTCENC_UBSAN})
-printopt("Unit tests     " ${ASTCENC_UNITTEST})
+printopt("Invariance         " ${ASTCENC_INVARIANCE})
+printopt("Shared libs        " ${ASTCENC_SHAREDLIB})
+printopt("Decompressor       " ${ASTCENC_DECOMPRESSOR})
+message(STATUS "Developer options")
+printopt("Diagnostics        " ${ASTCENC_DIAGNOSTICS})
+printopt("ASAN               " ${ASTCENC_ASAN})
+printopt("UBSAN              " ${ASTCENC_UBSAN})
+printopt("Unit tests         " ${ASTCENC_UNITTEST})
 
 # Subcomponents
 add_subdirectory(Source)

=== Source/CMakeLists.txt ===
--- 
+++ 
@@ -27,8 +27,8 @@
     set(ASTCENC_CODEC enc)
 endif()
 
-set(ASTCENC_ARTIFACTS native none neon avx2 sse4.1 sse2)
-set(ASTCENC_CONFIGS ${ASTCENC_ISA_NATIVE} ${ASTCENC_ISA_NONE} ${ASTCENC_ISA_NEON} ${ASTCENC_ISA_AVX2} ${ASTCENC_ISA_SSE41} ${ASTCENC_ISA_SSE2})
+set(ASTCENC_ARTIFACTS native none sve_256 sve_128 neon avx2 sse4.1 sse2)
+set(ASTCENC_CONFIGS ${ASTCENC_ISA_NATIVE} ${ASTCENC_ISA_NONE} ${ASTCENC_ISA_SVE_256} ${ASTCENC_ISA_SVE_128} ${ASTCENC_ISA_NEON} ${ASTCENC_ISA_AVX2} ${ASTCENC_ISA_SSE41} ${ASTCENC_ISA_SSE2})
 list(LENGTH ASTCENC_ARTIFACTS ASTCENC_ARTIFACTS_LEN)
 math(EXPR ASTCENC_ARTIFACTS_LEN "${ASTCENC_ARTIFACTS_LEN} - 1")
 
@@ -38,7 +38,11 @@
     if(${ASTCENC_CONFIG})
         set(ASTCENC_ISA_SIMD ${ASTCENC_ARTIFACT})
 
-        if(${ASTCENC_ISA_SIMD} MATCHES "neon")
+        if(${ASTCENC_ISA_SIMD} MATCHES "sve_256")
+           # Not suported on macOS
+        elseif(${ASTCENC_ISA_SIMD} MATCHES "sve_128")
+           # Not suported on macOS
+        elseif(${ASTCENC_ISA_SIMD} MATCHES "neon")
            set(CMAKE_OSX_ARCHITECTURES arm64)
         elseif(${ASTCENC_ISA_SIMD} MATCHES "sse2")
            set(CMAKE_OSX_ARCHITECTURES x86_64)

=== debian/changelog ===
astc-encoder (5.1.0+ds-2) unstable; urgency=medium

  * Fix FTBFS with s390x (big endian issue)

 -- Timo Röhling <roehling@debian.org>  Wed, 04 Dec 2024 08:42:46 +0100

astc-encoder (5.1.0+ds-1) unstable; urgency=medium

  * Update d/watch to latest GitHub recipe
  * New upstream version 5.1.0+ds
  * Update patches
  * Wrap and sort Debian package files

 -- Timo Röhling <roehling@debian.org>  Tue, 03 Dec 2024 13:34:00 +0100

=== debian/control ===
--- 
+++ 
@@ -3,8 +3,8 @@
 Priority: optional
 Maintainer: Timo Röhling <roehling@debian.org>
 Build-Depends:
+ cmake,
  debhelper-compat (= 13),
- cmake,
  libgtest-dev <!nocheck>,
  libstb-dev,
  libtinyexr-dev,
@@ -36,6 +36,19 @@
  This package provides the command-line tool to compress and decompress
  images.
 
+Package: libastcenc-dev
+Section: libdevel
+Architecture: any
+Depends:
+ libastcenc5d (= ${binary:Version}),
+ ${misc:Depends},
+Multi-Arch: same
+Description: ${source:Synopsis} library headers
+ ${source:Extended-Description}
+ .
+ This package provides the development headers to include ASTC support
+ in other applications.
+
 Package: libastcenc5d
 Section: libs
 Architecture: any
@@ -47,16 +60,3 @@
  ${source:Extended-Description}
  .
  This package provides the runtime library for ASTC support.
-
-Package: libastcenc-dev
-Section: libdevel
-Architecture: any
-Depends:
- ${misc:Depends},
- libastcenc5d (= ${binary:Version}),
-Multi-Arch: same
-Description: ${source:Synopsis} library headers
- ${source:Extended-Description}
- .
- This package provides the development headers to include ASTC support
- in other applications.

## astc-encoder 5.2.0+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 #  SPDX-License-Identifier: Apache-2.0
 #  ----------------------------------------------------------------------------
-#  Copyright 2020-2024 Arm Limited
+#  Copyright 2020-2025 Arm Limited
 #
 #  Licensed under the Apache License, Version 2.0 (the "License"); you may not
 #  use this file except in compliance with the License. You may obtain a copy
@@ -25,7 +25,7 @@
     add_compile_options("/wd4324")
 endif()
 
-project(astcencoder VERSION 5.1.0)
+project(astcencoder VERSION 5.2.0)
 
 set(CMAKE_CXX_STANDARD 14)
 set(CMAKE_CXX_STANDARD_REQUIRED ON)

=== Source/CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 #  SPDX-License-Identifier: Apache-2.0
 #  ----------------------------------------------------------------------------
-#  Copyright 2020-2024 Arm Limited
+#  Copyright 2020-2025 Arm Limited
 #
 #  Licensed under the Apache License, Version 2.0 (the "License"); you may not
 #  use this file except in compliance with the License. You may obtain a copy
@@ -104,6 +104,19 @@
     set(INSTALL_GTEST OFF CACHE BOOL "" FORCE)
     set(CMAKE_OSX_ARCHITECTURES x86_64;arm64)
     add_subdirectory(GoogleTest)
+
+    # Workaround GoogleTest CRT selection issue issue
+    # See https://github.com/google/googletest/issues/4067
+    set_property(
+        TARGET gtest
+            PROPERTY
+                MSVC_RUNTIME_LIBRARY "MultiThreaded$<$<CONFIG:Debug>:Debug>")
+
+    set_property(
+        TARGET gtest_main
+            PROPERTY
+                MSVC_RUNTIME_LIBRARY "MultiThreaded$<$<CONFIG:Debug>:Debug>")
+
     enable_testing()
     add_subdirectory(UnitTest)
 endif()

=== debian/changelog ===
astc-encoder (5.2.0+ds-1) unstable; urgency=medium

  * New upstream version 5.2.0+ds
  * Update d/copyright and d/symbols
  * Refresh patches (no functional changes)
  * Bump Standards-Version to 4.7.2

 -- Timo Röhling <roehling@debian.org>  Tue, 11 Mar 2025 09:23:15 +0100

=== debian/control ===
--- 
+++ 
@@ -11,7 +11,7 @@
  libz-dev,
  pkgconf <!nocheck>,
 Homepage: https://github.com/ARM-software/astc-encoder
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Rules-Requires-Root: no
 Vcs-Git: https://salsa.debian.org/roehling/astc-encoder.git
 Vcs-Browser: https://salsa.debian.org/roehling/astc-encoder

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk

export DEB_BUILD_MAINT_OPTIONS = hardening=+all reproducible=+all future=+lfs
export DEB_CXXFLAGS_MAINT_APPEND = -DASTCENC_NEON=0

SOVERSION := 5d
UNITTEST := $(if $(or $(filter i386 %-i386,$(DEB_HOST_ARCH)),$(filter nocheck,$(DEB_BUILD_OPTIONS))),OFF,ON)

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure --buildsystem=cmake -- \
		-DBUILD_SHARED_LIBS=ON \
		-DCMAKE_SKIP_RPATH=ON \
		-DASTCENC_VERSION=$(shell echo $(DEB_VERSION_UPSTREAM) | sed 's/+ds.*//') \
		-DASTCENC_SOVERSION=$(SOVERSION) \
		-DASTCENC_UNITTEST=$(UNITTEST) \
		-DASTCENC_SHAREDLIB=ON

## astc-encoder 5.3.0+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -25,7 +25,7 @@
     add_compile_options("/wd4324")
 endif()
 
-project(astcencoder VERSION 5.2.0)
+project(astcencoder VERSION 5.3.0)
 
 set(CMAKE_CXX_STANDARD 14)
 set(CMAKE_CXX_STANDARD_REQUIRED ON)
@@ -45,6 +45,7 @@
 option(ASTCENC_ISA_NATIVE "Enable astcenc builds for native SIMD")
 option(ASTCENC_DECOMPRESSOR "Enable astcenc builds for decompression only")
 option(ASTCENC_SHAREDLIB "Enable astcenc builds with core library shared objects")
+option(ASTCENC_BIG_ENDIAN "Enable astcenc big-endian support")
 option(ASTCENC_DIAGNOSTICS "Enable astcenc builds with diagnostic trace")
 option(ASTCENC_ASAN "Enable astcenc builds with address sanitizer")
 option(ASTCENC_UBSAN "Enable astcenc builds with undefined behavior sanitizer")
@@ -52,6 +53,7 @@
 option(ASTCENC_INVARIANCE "Enable astcenc floating point invariance" ON)
 option(ASTCENC_CLI "Enable build of astcenc command line tools" ON)
 option(ASTCENC_X86_GATHERS "Enable use of native x86 gathers" ON)
+option(ASTCENC_WERROR "Force builds to treat warnings as errors" ON)
 
 # Preflight for some macOS-specific build options
 if("${CMAKE_SYSTEM_NAME}" STREQUAL "Darwin")
@@ -137,6 +139,9 @@
     printopt("Universal bin      " ${ASTCENC_UNIVERSAL_BUILD})
 endif()
 printopt("Invariance         " ${ASTCENC_INVARIANCE})
+if(${ASTCENC_BIG_ENDIAN})
+    printopt("Big endian         " ${ASTCENC_BIG_ENDIAN})
+endif()
 printopt("Shared libs        " ${ASTCENC_SHAREDLIB})
 printopt("Decompressor       " ${ASTCENC_DECOMPRESSOR})
 message(STATUS "Developer options")

=== Source/CMakeLists.txt ===
--- 
+++ 
@@ -17,8 +17,12 @@
 
 # Overwrite the LTO flags to force fat LTO; worth 3-4% performance
 # See https://gitlab.kitware.com/cmake/cmake/-/issues/16808
-if(CMAKE_CXX_COMPILER_ID MATCHES "GNU|Clang" AND ${ASTCENC_CLI})
+if(CMAKE_CXX_COMPILER_ID MATCHES "Clang" AND ${ASTCENC_CLI})
     set(CMAKE_CXX_COMPILE_OPTIONS_IPO "-flto")
+endif()
+
+if(CMAKE_CXX_COMPILER_ID MATCHES "GNU" AND ${ASTCENC_CLI})
+    set(CMAKE_CXX_COMPILE_OPTIONS_IPO "-flto=auto")
 endif()
 
 if(${ASTCENC_DECOMPRESSOR})

=== Source/UnitTest/CMakeLists.txt ===
--- 
+++ 
@@ -15,8 +15,8 @@
 #  under the License.
 #  ----------------------------------------------------------------------------
 
-set(ASTCENC_ARTIFACTS native none neon avx2 sse4.1 sse2)
-set(ASTCENC_CONFIGS ${ASTCENC_ISA_NATIVE} ${ASTCENC_ISA_NONE} ${ASTCENC_ISA_NEON} ${ASTCENC_ISA_AVX2} ${ASTCENC_ISA_SSE41} ${ASTCENC_ISA_SSE2})
+set(ASTCENC_ARTIFACTS native none sve_256 sve_128 neon avx2 sse4.1 sse2)
+set(ASTCENC_CONFIGS ${ASTCENC_ISA_NATIVE} ${ASTCENC_ISA_NONE} ${ASTCENC_ISA_SVE_256} ${ASTCENC_ISA_SVE_128} ${ASTCENC_ISA_NEON} ${ASTCENC_ISA_AVX2} ${ASTCENC_ISA_SSE41} ${ASTCENC_ISA_SSE2})
 list(LENGTH ASTCENC_ARTIFACTS ASTCENC_ARTIFACTS_LEN)
 math(EXPR ASTCENC_ARTIFACTS_LEN "${ASTCENC_ARTIFACTS_LEN} - 1")
 
@@ -26,7 +26,11 @@
     if(${ASTCENC_CONFIG})
         set(ASTCENC_ISA_SIMD ${ASTCENC_ARTIFACT})
 
-        if(${ASTCENC_ISA_SIMD} MATCHES "neon")
+        if(${ASTCENC_ISA_SIMD} MATCHES "sve_256")
+           # Not supported on macOS
+        elseif(${ASTCENC_ISA_SIMD} MATCHES "sve_128")
+           # Not supported on macOS
+        elseif(${ASTCENC_ISA_SIMD} MATCHES "neon")
            set(CMAKE_OSX_ARCHITECTURES arm64)
         elseif(${ASTCENC_ISA_SIMD} MATCHES "sse2")
            set(CMAKE_OSX_ARCHITECTURES x86_64)

=== Utils/Example/CMakeLists.txt ===
#  SPDX-License-Identifier: Apache-2.0
#  ----------------------------------------------------------------------------
#  Copyright 2021 Arm Limited
#
#  Licensed under the Apache License, Version 2.0 (the "License"); you may not
#  use this file except in compliance with the License. You may obtain a copy
#  of the License at:
#
#      http://www.apache.org/licenses/LICENSE-2.0
#
#  Unless required by applicable law or agreed to in writing, software
#  distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
#  WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
#  License for the specific language governing permissions and limitations
#  under the License.
#  ----------------------------------------------------------------------------

# CMake configuration
cmake_minimum_required(VERSION 3.15)
include(ExternalProject)

project(astcencoder_example VERSION 1.1.0)

# Add the external project and pull out the project directories we need

# The default build is a native build which supports the highest level of SIMD
# exposed by the compiler when using default compiler flags. Add a single
# SIMD enable to the CMAKE_CACHE_ARGS option to force something specific, but
# remember to change the link library in target_link_libraries() to match.
#
#  *  Add "-DASTCENC_ISA_SSE2:String=ON" and link against "astcenc-sse2-static"
#  *  Add "-DASTCENC_ISA_SSE41:String=ON" and link against "astcenc-sse4.1-static"
#  *  Add "-DASTCENC_ISA_AVX2:String=ON" and link against "astcenc-avx2-static"
#  *  Add "-DASTCENC_ISA_NEON:String=ON" and link against "astcenc-neon-static"
ExternalProject_Add(astcencoder
    GIT_REPOSITORY https://github.com/ARM-software/astc-encoder
    GIT_TAG main
    CMAKE_CACHE_ARGS -DASTCENC_CLI:STRING=OFF -DCMAKE_BUILD_TYPE:STRING=${CMAKE_BUILD_TYPE}
    INSTALL_COMMAND "")

ExternalProject_Get_property(astcencoder
    SOURCE_DIR)

ExternalProject_Get_property(astcencoder
    BINARY_DIR)

# Build the command line
add_executable(astcenc_example astc_api_example.cpp)

# ... with astcencoder as a dependency
add_dependencies(astcenc_example astcencoder)

# ... with astcencoder Source dir on the include path
target_include_directories(astcenc_example
    PRIVATE
        ${SOURCE_DIR}/Source)

# ... with astcencoder Binary dir on the library path and as a library dep
target_link_directories(astcenc_example
    PRIVATE
        ${BINARY_DIR}/Source)

target_link_libraries(astcenc_example
    PRIVATE
        astcenc-native-static)

=== debian/changelog ===
astc-encoder (5.3.0+ds-5) unstable; urgency=medium

  * Make autopkgtest endianness aware (Closes: #1111975)

 -- Timo Röhling <roehling@debian.org>  Thu, 18 Sep 2025 21:48:36 +0200

astc-encoder (5.3.0+ds-4) unstable; urgency=medium

  * Copy missing file to fix autopkgtest

 -- Timo Röhling <roehling@debian.org>  Wed, 20 Aug 2025 09:59:28 +0200

astc-encoder (5.3.0+ds-3) unstable; urgency=medium

  * Define ASTCENC_BIG_ENDIAN for all backends

 -- Timo Röhling <roehling@debian.org>  Tue, 19 Aug 2025 11:25:23 +0200

astc-encoder (5.3.0+ds-2) unstable; urgency=medium

  * Properly handle big endian architectures

 -- Timo Röhling <roehling@debian.org>  Tue, 19 Aug 2025 10:01:38 +0200

astc-encoder (5.3.0+ds-1) unstable; urgency=medium

  * New upstream version 5.3.0+ds
  * Update patches.
    Obsolete: 0002-Do-not-build-with-Werror.patch
  * Wrap and sort Debian package files
  * Disable warnings as errors via new upstream build option

 -- Timo Röhling <roehling@debian.org>  Mon, 18 Aug 2025 09:21:17 +0200

=== debian/control ===
--- 
+++ 
@@ -3,8 +3,8 @@
 Priority: optional
 Maintainer: Timo Röhling <roehling@debian.org>
 Build-Depends:
+ debhelper-compat (= 13),
  cmake,
- debhelper-compat (= 13),
  libgtest-dev <!nocheck>,
  libstb-dev,
  libtinyexr-dev,

=== debian/rules ===
--- 
+++ 
@@ -18,4 +18,6 @@
 		-DASTCENC_VERSION=$(shell echo $(DEB_VERSION_UPSTREAM) | sed 's/+ds.*//') \
 		-DASTCENC_SOVERSION=$(SOVERSION) \
 		-DASTCENC_UNITTEST=$(UNITTEST) \
+		-DASTCENC_WERROR=OFF \
+		-DASTCENC_BIG_ENDIAN=$(if $(filter big,$(DEB_HOST_ARCH_ENDIAN)),ON,OFF) \
 		-DASTCENC_SHAREDLIB=ON

=== debian/tests/control ===
Tests:
 test-suite,
Depends:
 cmake,
 g++ | c++-compiler,
 libastcenc-dev,
 libgtest-dev,
Architecture: !i386
Restrictions:
 allow-stderr,

=== debian/watch ===
version=4
opts=\
 filenamemangle=s%.*/@ANY_VERSION@%@PACKAGE@-$1.tar.gz%,\
 downloadurlmangle=s%(api.github.com/repos/[^/]+/[^/]+)/git/refs/%$1/tarball/refs/%g,\
 dversionmangle=auto,oversionmangle=s%$%+ds%,repack,\
 searchmode=plain \
 https://api.github.com/repos/ARM-software/astc-encoder/git/matching-refs/tags/ \
 https://api.github.com/repos/[^/]+/[^/]+/git/refs/tags/@ANY_VERSION@
